#region Copyright
/*
 * Copyright 2005-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Collections.Generic;
using Seasar.Framework.Aop;
using System.Reflection;
using Seasar.Quill.Attrs;
using Seasar.Quill.Util;
using Seasar.Framework.Aop.Impl;

namespace Seasar.Quill
{
    /// <summary>
    /// Aspect`\zNX
    /// </summary>
    /// <remarks>
    /// <para>
    /// AspectKpꍇ̓C^[tF[XENX̓\bh
    /// <see cref="Seasar.Quill.Attrs.AspectAttribute"/>()
    /// ݒ肳ĂKvB
    /// </para>
    /// </remarks>
    public class AspectBuilder
    {
        // AspectBuilderŎgpQuillContainer
        // (Interceptor擾ׂɎgp)
        protected QuillContainer container;

        /// <summary>
        /// AspectBuilder邽߂̃RXgN^
        /// </summary>
        /// <param name="container">AspectBuilderŎgpQuillContainer</param>
        public AspectBuilder(QuillContainer container)
        {
            // AspectBuilderŎgp邽߂QuillContainer
            // RXgN^󂯎
            this.container = container;
        }

        /// <summary>
        /// w肳ꂽ<code>type</code>̑mF
        /// Aspect`̔z쐬
        /// </summary>
        /// <param name="type">Aspect`mFType</param>
        /// <returns>쐬ꂽAspect`̔z</returns>
        public virtual IAspect[] CreateAspects(Type type)
        {
            // Aspect̃Xg
            List<IAspect> aspectList = new List<IAspect>();

            // TypeɎw肳ꂽAspectw肷鑮擾
            AspectAttribute[] attrsByType = AttributeUtil.GetAspectAttrs(type);

            // TypeɎw肳ĂAspecťAAspectXgɒǉ
            foreach (AspectAttribute attrByType in attrsByType)
            {
                // PointcutɑSẴ\bhǉĂAspect쐬
                IAspect aspect = CreateAspect(attrByType);

                // 쐬AspectXgɒǉ
                aspectList.Add(aspect);
            }

            // typeŐ錾Ă郁\bh擾
            MethodInfo[] methods = type.GetMethods(BindingFlags.Public | 
                BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Static);

            // MethodɎw肳ĂAspectXgɒǉ
            aspectList.AddRange(CreateAspectList(methods));

            // Aspect̔zԂ
            return aspectList.ToArray();
        }

        /// <summary>
        /// w肳ꂽ\bhAspectLƂȂAspect`̃Xg쐬
        /// </summary>
        /// <param name="methods">\bh̔z</param>
        /// <returns>w肳ꂽ\bhAspectLƂȂAspect`̃Xg</returns>
        protected virtual IList<IAspect> CreateAspectList(MethodInfo[] methods)
        {
            // InterceptorpointcutƂȂ郁\bhi[
            IDictionary<IMethodInterceptor, List<string>> methodNames =
                new Dictionary<IMethodInterceptor, List<string>>();

            // \bȟAAspectmFPointcut쐬ׂ̃\bhǉ
            foreach (MethodInfo method in methods)
            {
                // AspectmFPointcut쐬ׂ̃\bhǉ
                AddMethodNamesForPointcut(methodNames, method);
            }

            // Aspect̃Xg
            List<IAspect> aspectList = new List<IAspect>();

            // InterceptořAAspect쐬
            foreach (IMethodInterceptor interceptor in methodNames.Keys)
            {
                // Interceptorƃ\bh̔z񂩂Aspect쐬
                IAspect aspect = CreateAspect(
                    interceptor, methodNames[interceptor].ToArray());

                // Aspect̃Xgɒǉ
                aspectList.Add(aspect);
            }

            // Aspect̃XgԂ
            return aspectList.ToArray();
        }

        /// <summary>
        /// SẴ\bhAspectLƂȂAspect`쐬
        /// </summary>
        /// <param name="aspectAttr">Aspectݒ肷鑮</param>
        /// <returns>SẴ\bhAspectLƂȂAspect`</returns>
        protected virtual IAspect CreateAspect(AspectAttribute aspectAttr)
        {
            // Interceptor쐬
            IMethodInterceptor interceptor = GetMethodInterceptor(aspectAttr);

            // InterceptorAspect쐬
            // (Pointcut͎w肵Ȃ̂őSẴ\bhΏۂƂȂ)
            IAspect aspect = new AspectImpl(interceptor);

            // AspectԂ
            return aspect;
        }

        /// <summary>
        /// C^[Zv^[ƃ\bhw肵Aspect`쐬
        /// </summary>
        /// <param name="interceptor">C^[Zv^[</param>
        /// <param name="methodNames">AspectKp郁\bh̔z</param>
        /// <returns>w肳ꂽ\bhAspectLƂȂAspect`</returns>
        protected virtual IAspect CreateAspect(
            IMethodInterceptor interceptor, string[] methodNames)
        {
            // Pointcut쐬
            IPointcut pointcut = new PointcutImpl(methodNames);

            // InterceptorPointcutAspect쐬
            IAspect aspect = new AspectImpl(interceptor, pointcut);

            // AspectԂ
            return aspect;
        }

        /// <summary>
        /// AspectmFPointcut쐬ׂ̃\bhǉ
        /// </summary>
        /// <param name="methodNames">
        /// InterceptorpointcutƂȂ郁\bhi[RNV
        /// </param>
        /// <param name="method">\bh</param>
        protected void AddMethodNamesForPointcut(
            IDictionary<IMethodInterceptor, List<string>> methodNames, MethodInfo method)
        {
            // \bhɎw肳ĂAspect擾
            AspectAttribute[] aspectAttrs =
                AttributeUtil.GetAspectAttrsByMethod(method);

            // AspecťAPointcut쐬ׂ̃\bhǉ
            foreach (AspectAttribute aspectAttr in aspectAttrs)
            {
                // Pointcut쐬ׂ̃\bhǉ
                AddMethodNamesForPointcut(methodNames, method.Name, aspectAttr);
            }
        }

        /// <summary>
        /// AspectmFPointcut쐬ׂ̃\bhǉ
        /// </summary>
        /// <param name="methodNames">
        /// InterceptorpointcutƂȂ郁\bhi[RNV
        /// </param>
        /// <param name="methodName">\bh</param>
        /// <param name="aspectAttr">Aspect</param>
        protected void AddMethodNamesForPointcut(
            IDictionary<IMethodInterceptor, List<string>> methodNames,
             string methodName, AspectAttribute aspectAttr)
        {
            // C^[Zv^[擾
            IMethodInterceptor interceptor = GetMethodInterceptor(aspectAttr);

            if (!methodNames.ContainsKey(interceptor))
            {
                // n߂ĂInterceptoȑꍇstring̃Xg
                methodNames.Add(interceptor, new List<string>());
            }

            // \bhǉ
            methodNames[interceptor].Add(methodName);
        }

        /// <summary>
        /// AspectC^[Zv^[擾
        /// </summary>
        /// <param name="aspectAttr">Aspect</param>
        /// <returns>C^[Zv^[</returns>
        protected virtual IMethodInterceptor GetMethodInterceptor(
            AspectAttribute aspectAttr)
        {
            if (aspectAttr.InterceptorType != null)
            {
                // interceptorTypew肳Ăꍇ
                // QuillTypew肵ăC^[Zv^[擾
                return GetMethodInterceptor(aspectAttr.InterceptorType);
            }
            else if (aspectAttr.ComponentName != null)
            {
                // R|[lgw肳Ăꍇ
                // S2ContainerR|[lgw肵ăC^[Zv^[擾
                return GetMethodInterceptor(aspectAttr.ComponentName);
            }
            else
            {
                // AspectinterceptorTypecomponentNamêǂ̎w
                // ĂȂꍇ͗OX[
                throw new QuillApplicationException("EQLL0013");
            }

        }

        /// <summary>
        /// QuillTypew肵ăC^[Zv^[擾
        /// </summary>
        /// <param name="interceptorType">C^[Zv^[Type</param>
        /// <returns>C^[Zv^[</returns>
        protected virtual IMethodInterceptor GetMethodInterceptor(
            Type interceptorType)
        {
            // Interceptor̃R|[lg擾
            QuillComponent component =
                container.GetComponent(interceptorType);

            if (typeof(IMethodInterceptor).IsAssignableFrom(component.ComponentType))
            {
                // IMethodInterceptorɑłꍇInterceptorԂ
                return (IMethodInterceptor)component.GetComponentObject(interceptorType);
            }
            else
            {
                // IMethodInterceptorɑłȂꍇ͗OX[
                throw new QuillApplicationException("EQLL0012",
                    new object[] { component.ComponentType.FullName });
            }
        }

        /// <summary>
        /// S2ContainerR|[lgw肵ăC^[Zv^[擾
        /// </summary>
        /// <param name="componentName">R|[lg</param>
        /// <returns>C^[Zv^[</returns>
        protected virtual IMethodInterceptor GetMethodInterceptor(
            string componentName)
        {
            // S2ContainerR|[lg̃IuWFNg擾
            object interceptor =
                SingletonS2ContainerConnector.GetComponent(componentName);

            // C^[Zv^[Type擾
            Type type = TypeUtil.GetType(interceptor);

            if (typeof(IMethodInterceptor).IsAssignableFrom(type))
            {
                // IMethodInterceptorɑłꍇInterceptorԂ
                return (IMethodInterceptor)interceptor;
            }
            else
            {
                // IMethodInterceptorɑłȂꍇ͗OX[
                throw new QuillApplicationException("EQLL0012",
                    new object[] { type.FullName });
            }
        }

    }
}
