#region Copyright
/*
 * Copyright 2005-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System.Reflection;
using Seasar.Quill.Attrs;
using Seasar.Quill.Util;

namespace Seasar.Quill.Unit
{
    /// <summary>
    /// MockInject邽߂̃NX
    /// </summary>
    public class MockInjector : QuillInjector
    {
        // MockInjector̃CX^X
        private static MockInjector mockInjector;

        /// <summary>
        /// MockInjectorRXgN^
        /// </summary>
        /// <remarks>
        /// <see cref="GetInstance"/>CX^X𐶐
        /// </remarks>
        /// <seealso cref="Seasar.Quill.Unit.MockInjector.GetInstance"/>
        protected MockInjector()
        {
        }

        /// <summary>
        /// MockInjector̃CX^X擾
        /// </summary>
        /// <remarks>
        /// <para>
        /// MockInjector̃RXgN^̃ANZXCqprotectedɐݒ肳ĂׁA
        /// MockInjector̃CX^X𐶐邱Ƃ͂łȂB
        /// </para>
        /// <para>
        /// MockInjector̃CX^X擾ꍇ͓\bhgpB
        /// </para>
        /// <para>
        /// {IɓCX^XԂADestroy\bhɂQuill
        /// QƂjĂꍇ͐VMockInjector̃CX^X쐬B
        /// </para>
        /// </remarks>
        /// <returns>QuillInjector̃CX^X</returns>
        public new static MockInjector GetInstance()
        {
            if (mockInjector == null)
            {
                mockInjector = new MockInjector();
            }

            // MockInjector̃CX^XԂ
            return mockInjector;
        }

        /// <summary>
        /// QuillInjectorQƂj
        /// </summary>
        public override void Destroy()
        {
            if (container == null)
            {
                return;
            }

            // QuillContainerQƂj
            container.Destroy();

            container = null;
            mockInjector = null;
        }

        /// <summary>
        /// w肷tB[hDIB
        /// </summary>
        /// <remarks>Mockw肳ĂꍇMockŎw肳ĂMockNX
        /// D悵InjectB</remarks>
        /// <param name="target">DIsIuWFNg</param>
        /// <param name="field">DIstB[h</param>
        protected override void InjectField(object target, FieldInfo field)
        {
            // tB[ȟ^ɐݒ肳ĂMock擾
            MockAttribute mockAttr = AttributeUtil.GetMockAttr(field.FieldType);

            if (mockAttr != null)
            {
                // MockInject
                InjectField(target, field, mockAttr.MockType);
            }
            else
            {
                // Mockw肳ĂȂꍇ͒ʏ̏s
                base.InjectField(target, field);
            }
        }
    }
}
